This page will give you an overview of the program and some of its features.

Table of content

* User interface
    * Node data
    * Graph
    * Console
    * Filter editor
* Navigate the graph
    * Zoom
    * Pan
* Node information

# User interface #
The user interface of the tool consist of multiple tabs and windows. Here we will give an overview of what some of these do.

Figure 1 below show how the program looks when you start it up:
![whole graph](https://bitbucket.org/repo/nnApqr/images/356382636-wholething.png)

*Figure 1. how the program looks on start up.* 

The tool is currently divided into 4 main windows.


### Node data (Left) ###
This window shows information about a selected node.

### Graph (Middle Top) ###
This window shows the tree in different structures. **There are 3 tabs.**

**The graph view shown in Figure 1**

**The Tree view seen Figure 2. **

![treeview.png](https://bitbucket.org/repo/nnApqr/images/1622986094-treeview.png)

*Figure 2. The same tree as in Figure 1, but as a tree view instead.*


** The class overview that show all classes that are present in the tree. Each class also tells you which other classes are children or parents in the tree of nodes the class. See Figure 3**

![classOverview.png](https://bitbucket.org/repo/nnApqr/images/3902810057-classOverview.png)

*Figure 3. The same graph as in Figure 1, but as a tree view instead.*

### Console (Middle Bottom) ###
This console will tell you all sorts of information when you debug your graph. Error messages, warnings and computed values are some stuff that can end up here.

### Filter editor (Right) ###
This is an GUI for editing the build in filter language for the system. Write your filter in the text area and when your done, press the "Apply filter" button above the text area. 

For more information on how to write a filter, see the [tutorial](https://bitbucket.org/jastadd/jastadddebugger-exjobb/wiki/The%20Filter%20Configuration%20Language).

# Navigate the graph#
You don't have to look at the whole big graph all the time, it is possible to move around in the graph view.

### Zoom ###
You can **zoom in and out by scrolling the mouse wheel** or **clicking the +/- button above the graph**. The center of the zoom is at the mouse pointer. If your interested in a specific node, hoover your cursor on it and zoom and the "camera" will move to that node.

### Pan ###
You can pan, or "drag", the view in the graph. This is done by **clicking and holding the scroll mouse button** OR **holding CTRL while holding down the left mouse button**

# Node information #
Each node in the tree usually contains a number of attributes and tokens. These can be seen by **clicking on a node with the left mouse button** and looking Node data window to the left. In Figure 4 we can see the information about the IdDecl node.

![nodeClick.png](https://bitbucket.org/repo/nnApqr/images/1110553901-nodeClick.png)

*Figure 4. IdDecl has been clicked and the information about this node is shown to the left in the Node data window.*

Above the table we can see the **class name of the clicked node**, and above that the **Java class parent chain.**

In the table we **see each attribute and token of the node**. This node has one inherited attribute debuggerConfig and two syntesized attributes print and aValue. a token getID is also part of the node.